#pragma once
#include <string>

// forward declaration (thanks to Nathan Hartland for the tip!) to avoid inclusion of LHAPDF.h here
namespace LHAPDF {
  class PDF;
}

namespace PDFinterface {

  enum nucleon {
    Proton    =  0,
    Neutron   =  1,
    Deuteron  =  2,
    Isoscalar =  2,
    Iron      = 14  
  };


  class PDFs {
  public:
    PDFs(std::string PDFset, int member=0);
    ~PDFs();
    
    double xfx(double x, double Q, int   parton);
    void   xfx(double x, double Q, double *pdfs);
    
    double xfx(double x, double Q, int   parton, nucleon nucl, bool antiparticle=false);
    void   xfx(double x, double Q, double *pdfs, nucleon nucl, bool antiparticle=false);

    double alphasQ(double mu);
    double getQuarkMass     (int flavour);
    double getQuarkThreshold(int flavour);

    void TurnOnOffPDFs(bool *activePDF); // takes an array of 13 elements

  private:
    double ConvertNucleonPDF(unsigned int parton, double xd, double xu, nucleon n);
    LHAPDF::PDF* lhpdf;
    bool excludePDF[13];

  };

};


